<template>
  <client-only>

    <v-date-picker
      v-model="localDate"
      class="datepicker datepicker-input"
      :locale="{ id: 'ru', firstDayOfWeek: 2, masks: { weekdays: 'WW' } }"
      :popover="{ visibility: 'focus' }"
      :min-date="new Date()"
      is-expanded
      :is-required="true"
      :input-props='{
        readonly: true
      }'
      :disabled-dates='[
        {
          weekdays: [
            ...disabledWeekdays,
            ...alwaysDisabledWeekdays
          ]
        },
        ...disabledDates.map((disableDate) => new Date(disableDate))
      ]'
    >

      <form-input label="Дата"
                  v-model="localDate"
                  :readonly="true"
                  :rightArrow="true"
                  :class="error ? 'error' : ''"
      />
    </v-date-picker>
  </client-only>
</template>

<script>
  import FormInput from './FormInput';

  export default {
    name: 'DatepickerInput',
    components: {
      FormInput
    },
    props: {
      date: {
        type: [ Date, String ],
        required: true
      },

      error: {
        type: Boolean,
        default: false,
      },

      disabledDates: {
        type: Array,
      },

      disabledWeekdays: {
        type: Array,
        default: () => []
      },

      alwaysDisabledWeekdays: {
        type: Array,
        default: () => []
      }
    },
    data: () => ({
      localDate: '',
    }),
    mounted() {
      this.localDate = this.date;
    },
    watch: {
      localDate() {
        if (!this.localDate)
          this.localDate = this.date;

        this.$emit('changeDate', this.localDate);
      },

      date() {
        this.localDate = this.date;
      }
    }
  }
</script>

<style lang="scss">
  @import '~assets/scss/variables.scss';
  @import '~assets/scss/mixins.scss';

  .datepicker-input {
    margin: 0;
    cursor: pointer;

    * {
      cursor: pointer;
    }
  }
</style>
